.\"	$OpenBSD: newsyslog.8,v 1.33 2003/02/12 19:17:36 millert Exp $
.\"
.\" Copyright (c) 1997, Jason Downs.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"      This product includes software developed by Jason Downs for the
.\"      OpenBSD system.
.\" 4. Neither the name(s) of the author(s) nor the name OpenBSD
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR(S) ``AS IS'' AND ANY EXPRESS
.\" OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
.\" WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
.\" DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR(S) BE LIABLE FOR ANY DIRECT,
.\" INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
.\" (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
.\" SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
.\" CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\" This file contains changes from the Open Software Foundation.
.\"
.\"	from: @(#)newsyslog.8
.\"
.\" Copyright 1988, 1989 by the Massachusetts Institute of Technology
.\"
.\" Permission to use, copy, modify, and distribute this software
.\" and its documentation for any purpose and without fee is
.\" hereby granted, provided that the above copyright notice
.\" appear in all copies and that both that copyright notice and
.\" this permission notice appear in supporting documentation,
.\" and that the names of M.I.T. and the M.I.T. S.I.P.B. not be
.\" used in advertising or publicity pertaining to distribution
.\" of the software without specific, written prior permission.
.\" M.I.T. and the M.I.T. S.I.P.B. make no representations about
.\" the suitability of this software for any purpose.  It is
.\" provided "as is" without express or implied warranty.
.\"
.TH NEWSYSLOG 8 "24 Jan 2003"
.SH NAME
\fBnewsyslog\fR \- maintain system log files to manageable sizes
.SH SYNOPSIS
\fBnewsyslog\fR [\fB\-FmnrvV\fR] [\fB\-a\fR \fIdirectory]\fR
[\fB\-f\fR \fIconfig_file]\fR [\fIlog\fR \fI...\fR]
.SH DESCRIPTION
.B newsyslog
is a program that should be scheduled to run periodically by
.BR cron (8).
When it is executed it archives log files if necessary.
If a log file is determined to require archiving,
.B newsyslog
rearranges the files so that
.I logfile
is empty,
.I logfile.0
has
the last period's logs in it,
.I logfile.1
has the next to last
period's logs in it, and so on, up to a user-specified number of
archived logs.
The archived logs may be optionally compressed to save space.
.LP
The options are as follows:
.TP
.B \-F
Force
.B newsyslog
to trim logs regardless of the size and/or age requirements specified in
.IR /etc/newsyslog.conf .
This option may be combined with the
.B \-n
or
.B \-v
flags to aid in debugging problems with
.IR /etc/newsyslog.conf .
.TP
.B \-m
Monitoring mode; only entries marked with an `M'
in flags are processed.
For each log file being monitored, any log output since the last time 
.B newsyslog
was run with the
.B \-m
flag is mailed to the user listed in the monitor notification section.
.TP
.B \-n
Do not trim the logs, but instead print out what would be done if this option
were not specified.
.TP
.B \-r
Removes the restriction that
.B newsyslog
must be running as root.
Of course,
.B newsyslog
will not be able to send a
.I SIGHUP
signal to
.BR syslogd (8),
so this option should only be used in debugging.
.TP
.B \-v
Place
.B newsyslog
in verbose mode.
In this mode it will print out each log and its
reasons for either trimming that log or skipping it.
.TP
.B \-V
Print version.
.TP
.BI \-a " directory"
Specify a
.I directory
into which archived log files will be written.
If
.I directory
is a relative path, it is appended to the parent directory
of each log and the archived log is stored in the result.
If an absolute path is given, all archived logs are stored in the given
.IR directory .
If
.I directory
does not exist for a specified log, it is ignored for that entry and
the log is rotated as if the
.B \-a
option was not specified.
.TP
.BI \-f " config_file"
Use
.I config_file
instead of
.I /etc/newsyslog.conf
for the configuration file.
.LP
If one or more
.I log
files are specified on the command line, only the specified logs will
be rotated.
Note that each
.I log
specified must have an entry in
.IR /etc/newsyslog.conf .
.LP
A log can be archived because of two reasons:
The log file can have
grown bigger than a preset size in kilobytes, or a preset number of
hours may have elapsed since the last log archive.
The granularity of
.B newsyslog
is dependent on how often it is scheduled to run in
.BR cron (8).
Since the program is quite fast, it may be scheduled to run every hour
without any ill effects.
.LP
When starting up,
.B newsyslog
reads in a configuration file to determine which logs should be looked
at.
By default, this configuration file is
.IR /etc/newsyslog.conf .
Each line of the file contains information about a particular log file
that should be handled by
.BR newsyslog .
Each line has five mandatory fields and up to three optional fields, with a
whitespace separating each field.
Blank lines or lines beginning with a hash mark (`#') are ignored.
The fields of the configuration file are as follows:
.TP 1.5i
\fIlogfile_name\fP
The full pathname of the system log file to be archived.
.TP
\fIowner:group\fP
This optional field specifies the owner and group for the archive file.
The `\&:' is essential, even if the
.I owner
or
.I group
field is left blank.
The fields may be numeric, or a name which is looked up
in the system password and group databases.
For backwards compatibility, a `\&.' may be used instead of a `\&:'.
.TP
\fImode\fP
File mode (in octal) to use for created log files and archives.
.TP
\fIcount\fP
The number of archives to be kept besides the log file itself.
.TP
\fIsize\fP
When the size of the log file (in kilobytes) reaches this point, the log
file is trimmed as described above.
If this field is replaced by an `*', then the size of
the log file is not taken into account when determining when to trim the
log file.
By default, files smaller than 512 bytes are not rotated unless the
`B' (binary) flag is set.
This prevents
.B newsyslog
from rotating files consisting solely of a message indicating
that the log file has been turned over.
.TP
\fIwhen\fP
The
.I when
field can consist of an interval, a specific time, or both.
If the
.I when
field consists of an asterisk (`*'),
log rotation will depend only on the contents of the
.I size
field.
Otherwise, the
.I when
field consists of an optional interval in hours, possibly followed
by an `@'-sign and a time in a restricted ISO 8601 format or by a `$'-sign
and a time specification for logfile rotation at a fixed time once
per day, per week or per month.
.sp
If a time is specified, the log file will only be trimmed if
.B newsyslog
is run within one hour of the specified time.
If an interval is specified, the log file will be trimmed if that
many hours have passed since the last rotation.
When both a time and an interval are specified, both conditions
must be satisfied for the rotation to take place.
.sp
There is no provision for the specification of a timezone.
There is little point in specifying an explicit minutes or seconds
component in the current implementation, since the only comparison is
`within the hour'.
.sp
.I ISO 8601 restricted time format
.br
The lead-in character for a restricted
.SM ISO 8601
time is an `@'-sign.
The particular format of the time in restricted
.SM ISO 8601
is: [[[[[cc]yy]mm]dd][T[hh[mm[ss]]]]].
Optional date fields default to the appropriate component of the
current date; optional time fields default to midnight
For example, if today is January 22, 1999, the following date specifications
are all equivalent:
.RS 2i
.TP
`19990122T000000'
.TP
`990122T000000'
.TP
`0122T000000'
.TP
`22T000000'
.TP
`T000000'
.TP
`T0000'
.TP
`T00'
.TP
`22T'
.TP
`T'
.TP
`'
.RE
.RS
.sp
.I Day, week and month time format
.br
The lead-in character for day, week and month specification is a `$'-sign.
The particular format of day, week and month specification is:
[Dhh], [Ww[Dhh]] and [Mdd[Dhh]], respectively.
Optional time fields default to midnight.
The ranges for day and hour specifications are:
.RS
.TP
.I hh
hours, range 0 ... 23
.TP
.I w
day of week, range 0 ... 6, 0 = Sunday
.TP
.I dd
day of month, range 1 ... 31, or the letter
.I L
or
.I l
to specify the last day of the month.
.RE
.sp
.I Some examples:
.br
.RS
.TP
.I $D0
rotate every night at midnight
(same as
.IR @T00 )
.TP
.I $D23
rotate every day at 23:00 hr
(same as
.IR @T23 )
.TP
.I $W0D23
rotate every week on Sunday at 23:00 hr
.TP
.I $W5D16
rotate every week on Friday at 16:00 hr
.TP
.I $M1D0
rotate on the first day of every month at midnight
(i.e., the start of the day; same as
.IR @01T00 )
.TP
.I $M5D6
rotate on every 5th day of the month at 6:00 hr
(same as
.IR @05T06 )
.RE
.RE
.TP
\fIflags\fP
The optional
.I flags
field specifies if the archives should have any special processing
done to the archived log files.
The `Z' flag will make the archive
files compressed to save space using
.BR gzip (1)
or
.BR compress (1),
depending on compilation options.
The `B' flag means that the file is a
binary file, and so the ASCII message which
.B newsyslog
inserts to indicate the fact that the logs have been turned over
should not be included.
The `M' flag marks this entry as a monitored log file.
The `F' flag specifies that symbolic links should be followed.
.TP
\fImonitor\fP
Specify the username (or email address) that should receive notification
messages if this is a monitored log file.
Notification messages are sent as email; the operator
deserves what they get if they mark the
.BR sendmail (8)
log file as monitored.
This field is only valid when the `M' flag is set.
.TP
\fIpid_file\fP
This optional field specifies a file containing the PID of a process to send a
.I SIGHUP
signal (usually
.IR SIGHUP )
to instead of
.IR /var/run/syslog.pid .
.TP
\fIsignal\fP
Specify the signal to send to the process instead of
.IR SIGHUP .
Signal names
must start with ``SIG'' and be the signal name, not the number, e.g.,
.IR SIGUSR1 .
.TP
\fIcommand\fP
This optional field specifies a command to run instead of sending a signal
to the process.
The command must be enclosed in double quotes (`\&"').
The empty string, `\&"\&"', can use used to prevent
.B newsyslog
from sending a signal or running a command.
You cannot specify both a command and a PID file.
.IR NOTE :
If you specify a command to be run,
.B newsyslog
will not send a
.IR SIGHUP to
.BR syslogd (8).
.SH FILES
.TP 24
.I /etc/newsyslog.conf
default configuration file
.SH SEE ALSO
.BR compress (1),
.BR gzip (1),
.BR syslog (3),
.BR syslogd (8)
.SH AUTHORS
.nf
Theodore Ts'o, MIT Project Athena
Copyright 1987, Massachusetts Institute of Technology
.fi
